//admob.initAdmob('ca-app-pub-2902360790797755/9716062020',"admob interstitial ID");


angular.module('demo', [
  'ionic',
  'ionic.service.core',
  'ionic.service.analytics',
  'ngCordova',
  'ngStorage',

  // modules
  // 'demo.adMob.ctrl',  -- not functioning right now
  'demo.appAvailability.ctrl',
  'demo.appRate.ctrl',
  'demo.barcodeScanner.ctrl',
  'demo.batteryStatus.ctrl',
  'demo.beacon.ctrl',
  'demo.camera.ctrl',
  'demo.clipboard.ctrl',
  'demo.contacts.ctrl',
  'demo.datePicker.ctrl',
  'demo.device.ctrl',
  'demo.deviceMotion.ctrl',
  'demo.deviceOrientation.ctrl',
  'demo.dialogs.ctrl',
  'demo.emailComposer.ctrl',
  'demo.facebook.ctrl',
  'demo.file.ctrl',
  'demo.fileOpener2.ctrl',
  'demo.fileTransfer.ctrl',
  'demo.flashlight.ctrl',
  'demo.geolocation.ctrl',
  'demo.globalization.ctrl',
  'demo.googleAnalytics.ctrl',
  'demo.healthkit.ctrl',
  'demo.inAppBrowser.ctrl',
  'demo.localNotification.ctrl',
  'demo.media.ctrl',
  'demo.network.ctrl',
  'demo.oauth.ctrl',
  'demo.preferences.ctrl',
  'demo.printer.ctrl',
  'demo.pushNotifications.ctrl',
  'demo.socialSharing.ctrl',
  'demo.sqlite.ctrl',
  'demo.statusbar.ctrl',
  'demo.toast.ctrl',
  'demo.touchid.ctrl',
  'demo.vibration.ctrl',
  'demo.upsPushNotifications.ctrl',
  'demo.chromecast.ctrl',
  'demo.start.ctrl',
  'demo.host.ctrl',
  'demo.waiting_room.ctrl',
  'demo.join.ctrl',
  'demo.game_arena.ctrl',
  'demo.final.ctrl'
])
  .run(function ($rootScope, $ionicPlatform, $cordovaNetwork, $cordovaBatteryStatus, $cordovaPush, $cordovaStatusbar, $ionicAnalytics) {

  	$rootScope.settings = {};

  	$ionicPlatform.ready(function () {

      $ionicAnalytics.register();

      var user = Ionic.User.current();
      if (!user.id) {
        user.id = Ionic.User.anonymousId();
        // user.id = 'your-custom-user-id';
      }
      user.save();


    var push = new Ionic.Push({
      "debug": false,
      "onNotification": function(notification) {
        var payload = notification.payload;
        console.log("Notification", notification, payload);
      },
      "onRegister": function(data) {
        console.log("Register", data);
      }
    });

    push.register(function(token) {
      user.addPushToken(token);
      user.save();
      console.log("Device token:",token.token);
    });

      if (window.cordova && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      }
      if (window.StatusBar) {
        StatusBar.styleDefault();
      }

      /*$cordovaLocalNotification.registerPermission().then(function () {
        //alert("registered");
      }, function () {
        //alert("denied registration");
      });

      var iosConfig = {
        "badge": true,
        "sound": true,
        "alert": true
      };
      $cordovaPush.register(iosConfig).then(function (result) {
        //alert("device token: " + result.deviceToken);
      }, function (error) {
        //alert("error " + error);
      });

      $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
        if (notification.alert) {
          navigator.notification.alert(notification.alert);
        }
        if (notification.sound) {
          var snd = new Media(event.sound);
          snd.play();
        }
        if (notification.badge) {
          $cordovaPush.setBadgeNumber(notification.badge).then(function (result) {
            // Success!
          }, function (err) {
            // An error occurred. Show a message to the user
          });
        }
      });*/


      $rootScope.$on("$cordovaNetwork:offline", function (event, result) {
        alert("Device is now Offline!");
      });


      $rootScope.$on("$cordovaNetwork:online", function (event, result) {
        alert("Device is Online!");
      });

      $rootScope.$on("$cordovaBatteryStatus:status", function (event, status) {
        //alert("status: " + status);
      });
    });
  })

  .config(function ($stateProvider, $urlRouterProvider, $cordovaFacebookProvider, $cordovaAppRateProvider, $cordovaInAppBrowserProvider) {

    if (!window.cordova) {
      var appID = 1234567890;
      var version = "v2.0"; // or leave blank and default is v2.0
      //$cordovaFacebookProvider.browserInit(appID, version);
    }

    var browserOptions = {
      location: "yes",
      toolbar: "yes"
    };


    document.addEventListener("deviceready", function () {
      var preferences = {
        iosURL: "some URL",
        appName: 'APP NAME',
        language: 'fr'
      };
      $cordovaAppRateProvider.setPreferences(preferences);
    }, false);

    $cordovaInAppBrowserProvider.setDefaultOptions(browserOptions);

    $stateProvider

      .state('menu', {
        url: "/menu",
        templateUrl: "app/menu.html"
      })

	.state('start', {
        url: "/start",
        templateUrl: "app/start/start.html",
        controller: "StartCtrl"
      })
      .state('host', {
        url: "/host",
        templateUrl: "app/host/host.html"
      })
      .state('final', {
        url: "/final",
        templateUrl: "app/final/final.html"
      })
      .state('join', {
        url: "/join",
        templateUrl: "app/join/join.html"
      })
      .state('waiting_room', {
        url: "/waiting_room",
        templateUrl: "app/waiting_room/waiting_room.html"
      })
      .state('game_arena', {
        url: "/game_arena",
        templateUrl: "app/game_arena/game_arena.html"
      })

      .state('about', {
        url: "/about",
        templateUrl: "app/about.html"
      })

      .state('chromecast', {
        url: "/chromecast",
        templateUrl: "app/chromecast/chromecast.html",
        controller: "ChromecastCtrl"
      })

      .state('appAvailability', {
        url: '/appAvailability',
        templateUrl: 'app/appAvailability/appAvailability.html',
        controller: "AppAvailabilityCtrl"
      })

      .state('appRate', {
        url: '/appRate',
        templateUrl: 'app/appRate/appRate.html',
        controller: "AppRateCtrl"
      })


      .state('barcodeScanner', {
        url: '/barcodeScanner',
        templateUrl: 'app/barcodeScanner/barcodeScanner.html',
        controller: "BarcodeScannerCtrl"
      })

      .state('batteryStatus', {
        url: '/batteryStatus',
        templateUrl: 'app/batteryStatus/batteryStatus.html',
        controller: "BatteryStatusCtrl"
      })

      .state('beacon', {
        url: '/beacon',
        templateUrl: 'app/beacon/beacon.html',
        controller: "BeaconCtrl"
      })

      .state('camera', {
        url: '/camera',
        templateUrl: 'app/camera/camera.html',
        controller: "CameraCtrl"
      })

      .state('clipboard', {
        url: '/clipboard',
        templateUrl: 'app/clipboard/clipboard.html',
        controller: "ClipboardCtrl"
      })

      .state('contacts', {
        url: '/contacts',
        templateUrl: 'app/contacts/contacts.html',
        controller: "ContactsCtrl"
      })


      .state('datePicker', {
        url: '/datePicker',
        templateUrl: 'app/datePicker/datePicker.html',
        controller: "DatePickerCtrl"
      })

      .state('device', {
        url: '/device',
        templateUrl: 'app/device/device.html',
        controller: "DeviceCtrl"
      })

      .state('deviceMotion', {
        url: '/deviceMotion',
        templateUrl: 'app/deviceMotion/deviceMotion.html',
        controller: "DeviceMotionCtrl"
      })


      .state('deviceOrientation', {
        url: '/deviceOrientation',
        templateUrl: 'app/deviceOrientation/deviceOrientation.html',
        controller: "DeviceOrientationCtrl"
      })

      .state('dialogs', {
        url: '/dialogs',
        templateUrl: 'app/dialogs/dialogs.html',
        controller: "DialogsCtrl"
      })

      .state('emailComposer', {
        url: '/emailComposer',
        templateUrl: 'app/emailComposer/emailComposer.html',
        controller: "EmailComposerCtrl"
      })

      .state('facebook', {
        url: '/facebook',
        templateUrl: 'app/facebook/facebook.html',
        controller: "FacebookCtrl"
      })

      .state('file', {
        url: '/file',
        templateUrl: 'app/file/file.html',
        controller: "FileCtrl"
      })

      .state('fileTransfer', {
        url: '/fileTransfer',
        templateUrl: 'app/fileTransfer/fileTransfer.html',
        controller: "FileTransferCtrl"
      })

      .state('fileOpener2', {
        url: '/fileOpener2',
        templateUrl: 'app/fileOpener2/fileOpener2.html',
        controller: "FileOpener2Ctrl"
      })

      .state('flashlight', {
        url: '/flashlight',
        templateUrl: 'app/flashlight/flashlight.html',
        controller: "FlashlightCtrl"
      })

      .state('geolocation', {
        url: '/geolocation',
        templateUrl: 'app/geolocation/geolocation.html',
        controller: "GeolocationCtrl"
      })

      .state('globalization', {
        url: '/global',
        templateUrl: 'app/globalization/globalization.html',
        controller: "GlobalizationCtrl"
      })

      .state('googleAnalytics', {
        url: '/googleAnalytics',
        templateUrl: 'app/googleAnalytics/googleAnalytics.html',
        controller: "GoogleAnalyticsCtrl"
      })

      .state('healthkit', {
        url: '/healthkit',
        templateUrl: 'app/healthkit/healthkit.html',
        controller: "HealthKitCtrl"
      })

      .state('inAppBrowser', {
        url: '/inAppBrowser',
        templateUrl: 'app/inAppBrowser/inAppBrowser.html',
        controller: "InAppBrowserCtrl"
      })

      .state('localNotification', {
        url: '/localNotification',
        templateUrl: 'app/localNotification/localNotification.html',
        controller: "LocalNotificationCtrl"
      })

      .state('media', {
        url: '/media',
        templateUrl: 'app/media/media.html',
        controller: "MediaCtrl"
      })

      .state('network', {
        url: '/network',
        templateUrl: 'app/network/network.html',
        controller: "NetworkCtrl"
      })

      .state('oauth', {
        url: '/oauth',
        templateUrl: 'app/oauth/oauth.html',
        controller: "OauthCtrl"
      })

      .state('preferences', {
        url: '/preferences',
        templateUrl: 'app/preferences/preferences.html',
        controller: "PreferencesCtrl"
      })

      .state('printer', {
        url: '/printer',
        templateUrl: 'app/printer/printer.html',
        controller: "PrinterCtrl"
      })

      .state('pushNotifications', {
        url: '/pushNotifications',
        templateUrl: 'app/pushNotifications/pushNotifications.html',
        controller: "PushNotificationsCtrl"
      })

      .state('socialSharing', {
        url: '/socialSharing',
        templateUrl: 'app/socialSharing/socialSharing.html',
        controller: "SocialSharingCtrl"
      })

      .state('sqlite', {
        url: '/sqlite',
        templateUrl: 'app/sqlite/sqlite.html',
        controller: "SqliteCtrl"
      })


      .state('statusbar', {
        url: '/statusbar',
        templateUrl: 'app/statusbar/statusbar.html',
        controller: "StatusbarCtrl"
      })


      .state('toast', {
        url: '/toast',
        templateUrl: 'app/toast/toast.html',
        controller: "ToastCtrl"
      })

      .state('touchid', {
        url: '/touchid',
        templateUrl: 'app/touchid/touchid.html',
        controller: "TouchIDCtrl"
      })

      .state('vibration', {
        url: '/vibration',
        templateUrl: 'app/vibration/vibration.html',
        controller: "VibrationCtrl"
      })

      .state('upsPushNotifications', {
        url: '/upsPushNotifications',
        templateUrl: 'app/upsPushNotifications/pushNotifications.html',
        controller: "UpsPushNotificationsCtrl"
      });

    $urlRouterProvider.otherwise('/start');
  })
.controller('AppCtrl', function ($scope, $rootScope, $http, $log, $cordovaPreferences, $interval, $timeout, $state, $window) {
	$rootScope.settings = {};

  $rootScope.connect = function(master) {
    store.register({
      id: "pack_cartoons",
      alias: "Pack Cartoons",
      type: store.PAID_SUBSCRIPTION
    });
		store.register({
      id: "pack_movies",
      alias: "Pack Colonne Sonore dei Film",
      type: store.PAID_SUBSCRIPTION
    });
		store.register({
      id: "pack_anthems",
      alias: "Pack Inni Nazionali",
      type: store.PAID_SUBSCRIPTION
    });

		store.refresh();

  		console.log("connect", master);

  		$rootScope.settings.confirmed_player = false;

  		if (!angular.isUndefined($rootScope.settings.n_players)) delete $rootScope.settings.n_players;

  		if (master == true) {
	  		$rootScope.settings.code = "";
	  		$rootScope.settings.players = [];
	  		$rootScope.settings.master = master;

	  		console.log($rootScope.settings);

	  		$rootScope.settings.players.push($rootScope.settings.name);

	  		$http.get("http://test.lucla.net/right/index.php/get_game_code").then(function(data) {
	  			$rootScope.settings.code = data.data.code;

	  			//$rootScope.settings.code = "1";

	  			if (!angular.isUndefined($rootScope.chromecast)) delete $rootScope.chromecast;

	  			ConnectSDK.discoveryManager.pickDevice().success(function(device) {
		  			console.log("launching chromecast");

		  			var webAppId;

		  			if (device.hasService(ConnectSDK.Services.WebOSTV)) {
					    webAppId = "http://test.lucla.net/chromecast/"; //"5G7328DE";
					} else if (device.hasService(ConnectSDK.Services.Chromecast)) {
					    webAppId = "68BE6ADA";
					} else if (device.hasService(ConnectSDK.Services.AirPlay)) {
					    webAppId = "http://test.lucla.net/chromecast/";
					}

					device.getWebAppLauncher().launchWebApp(webAppId).success(function(session) {
					    // Keep a reference to the session
					    $rootScope.chromecast = session.acquire();

					    // Open a communication channel to the app
					    $rootScope.chromecast.connect().success(function () {
					        console.log("web app connect success");
					    }).error(function (err) {
					        console.log("web app connect error: " + err.message, err);
                  /*$rootScope.chromecast.connect().success(function () {
    					        console.log("web app connect success");
    					    }).error(function (err) {
    					        console.log("web app connect error: " + err.message, err);
                      $rootScope.chromecast.connect().success(function () {
        					        console.log("web app connect success");
        					    }).error(function (err) {
        					        console.log("web app connect error: " + err.message, err);
        					    });
    					    });*/
					    });

					    // Make sure to release the session when done using it
					    $rootScope.chromecast.on("disconnect", function () {
					        $rootScope.chromecast.release();
					        $rootScope.chromecast = null;
					    });
					    console.log("inviate info", {status : "new_game", code : $rootScope.settings.code, rounds: $rootScope.settings.rounds});
					    $rootScope.chromecast.sendJSON({status : "new_game", code : $rootScope.settings.code, rounds: $rootScope.settings.rounds});

				    	$scope.enable_messages();
				    	$scope.enable_messages_master();
				    	$scope.subscribe_player();
					}).error(function (err) {
					    console.log("web app launch error: " + err.message);
					});
				});
	  		});
	  	} else {
	  		$scope.enable_messages();
	  		$scope.subscribe_player();
	  	}
	  	$state.go('waiting_room');
	  	cordova.plugins.backgroundMode.setDefaults({
    		title: "Recupera partita in attesa",
    		text: "La partita è ancora in corso..."
		});
	  	cordova.plugins.backgroundMode.enable();
	  	window.plugins.insomnia.keepAwake();
  	};

  	$scope.subscribe_player = function() {
  		console.log("subscribing", $rootScope.settings.name, device.uuid);
  		$rootScope.socket.emit('new_user', { name : $rootScope.settings.name, id : device.uuid });

  		if ($rootScope.settings.confirmed_player == false) {
  			$timeout($scope.subscribe_player, 2000);
  		}
  	};

	$scope.enable_messages = function() {
    if (!angular.isUndefined($rootScope.socket)) {
      console.log("closing socket 1",   $rootScope.socket);
      $rootScope.socket.close();
      //delete $rootScope.socket;
      console.log("closing socket 2");
    }
    console.log("enabling messages",  $rootScope.settings);
		$rootScope.socket = io('http://31.14.139.245:3000/', {query: 'code='+'game-' + $rootScope.settings.code});
    console.log("enabling messages actived", $rootScope.socket);
		$rootScope.socket.removeListener('ok_player');
		$rootScope.socket.on('ok_player', function(msg) {
			console.log("ok_player");
			console.log(msg, "vs", device.uuid);
			if (msg == device.uuid) {
				$rootScope.settings.confirmed_player = true;
			}
		});
    $rootScope.socket.removeListener('n_players');
		$rootScope.socket.on('n_players', function(msg) {
			console.log("update n_players", msg);
			$scope.$apply(function () {
				$rootScope.settings.n_players = msg;
			});
		});
    $rootScope.socket.removeListener('start_game_ok');
		$rootScope.socket.on('start_game_ok', function(msg) {
			console.log("starting_game", msg);
			$scope.$apply(function () {
				$state.go('game_arena');
			});
		});
	};
	$scope.enable_messages_master = function() {
		/*$rootScope.socket.removeListener('chromecast_ready');
		$rootScope.socket.on('chromecast_ready', function(msg) {
			$rootScope.socket.emit('new_user', $rootScope.settings.name);
		});*/
	};

	$rootScope.start_game = function() {
		$rootScope.socket.emit('start_game', 'yeahhhh');
	};
});



document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
    StatusBar.hide();
    AndroidFullScreen.immersiveMode(function() { }, function() { });

      if (AdMob)
	      AdMob.createBanner( {
		    adId: "ca-app-pub-2902360790797755/9716062020",
		    position: AdMob.AD_POSITION.BOTTOM_CENTER,
		    autoShow: true
		  });

	document.addEventListener('backbutton', function (event) {
	    event.preventDefault();
	    event.stopPropagation();
	  }, false);
}
