

angular.module('demo.game_arena.ctrl', [])
	.controller('GameArenaCtrl', function ($scope, $rootScope, $log, $cordovaPreferences, $http, $cordovaVibration, $timeout, $state) {

		$rootScope.settings.buzz = false;
		$rootScope.settings.show_answers = false;
		$rootScope.settings.show_waiting_for_start_round = false;
		$rootScope.settings.answers_src = "";
		$rootScope.settings.show_winner = false;
		$rootScope.settings.choose_level = false;


		$rootScope.start_round = function() {
			//$rootScope.socket.removeListener('waiting_for_start_round');
			$rootScope.settings.show_waiting_for_start_round = false;
			$rootScope.socket.emit("start_round", {id: device.uuid});
		};

		$rootScope.socket.on("choose_level", function(packs) {
			$scope.tmp_packs = packs;
			$rootScope.checkOrders();
		});

		$rootScope.checkOrders = function() {
			$scope.$apply(function() {
				$rootScope.settings.packs = $scope.tmp_packs;
				angular.forEach($rootScope.settings.packs.available_packs, function(pack, k) {
							store.once("pack_"+pack.id).updated(function (product) {
								$scope.$apply(function() {
									console.log("when owned A");
									console.log("test? A", product, angular.copy($rootScope.settings.packs.available_packs[k]));
									if (product.owned && $rootScope.settings.packs.available_packs[k].disabled == true) {
										console.log("update level A", $rootScope.settings.packs.available_packs[k], $rootScope.settings.packs.available_packs[k].disabled);
										$rootScope.settings.packs.available_packs[k].disabled = false;
										console.log("update level2 A", $rootScope.settings.packs.available_packs[k], $rootScope.settings.packs.available_packs[k].disabled);
										$rootScope.socket.emit("update_level", $rootScope.settings.packs.available_packs[k]);
									}
								});
							});
							var product = store.get("pack_"+pack.id);
							if (!angular.isUndefined(product)) {
								if (product.state == "approved") {
									product.finish();
								}
								store.once("pack_"+pack.id).owned(function (product) {
									$scope.$apply(function() {
										console.log("when owned B");
										console.log("test? B", product, angular.copy($rootScope.settings.packs.available_packs[k]));
										if (product.owned && $rootScope.settings.packs.available_packs[k].disabled == true) {
											console.log("update level B", $rootScope.settings.packs.available_packs[k], $rootScope.settings.packs.available_packs[k].disabled);
											delete $rootScope.settings.packs.available_packs[k].disabled;
											console.log("update level2 B", $rootScope.settings.packs.available_packs[k], $rootScope.settings.packs.available_packs[k].disabled);
											$rootScope.socket.emit("update_level", $rootScope.settings.packs.available_packs[k]);
										}
									});
								});
							}

					});
				$rootScope.settings.choose_level = true;
			});
		};

		$rootScope.socket.on("start_round", function() {
			$scope.$apply(function() {
				$rootScope.settings.show_waiting_for_start_round = false;
				$rootScope.settings.choose_level = true;
			});
		});

		$rootScope.socket.on('waiting_for_start_round', function(msg) {
			$scope.$apply(function() {
				console.log("waiting_for_start_round");
				if ($rootScope.settings.master == true) {
					$rootScope.settings.buzz = false;
					$rootScope.settings.show_answers = false;
					$rootScope.settings.show_waiting_for_start_round = true;
					console.log("settings", $rootScope.settings);
				} else {
					console.log("no master");
				}
			});
		});

		$rootScope.socket.on('enable_buzz', function(msg) {
			$rootScope.settings.show_waiting_for_start_round = false;
			$rootScope.socket.removeListener("all_answers");
			$scope.$apply(function() {
				$rootScope.settings.choose_level = false;
				if (msg == "true") {
					delete $rootScope.settings.answers;
					$rootScope.settings.show_answers = false;
					$cordovaVibration.vibrate(100);
					$rootScope.settings.buzz = true;
				} else
					$rootScope.settings.buzz = false;
			});
		});

		$rootScope.socket.on('enable_answers', function(msg) {
			$scope.$apply(function() {
				console.log("enable_answers", "enable answers");
				$scope.answers();
			});
		});

		$rootScope.socket.on('disable_answers', function(msg) {
			$scope.$apply(function() {
				console.log("disable_answers", "disable answers");
				$rootScope.settings.show_answers = false;
			});
		});

		$scope.buzz = function() {
			$rootScope.socket.emit("buzz", {id: device.uuid});

			$scope.answers();
		};

		$scope.answers = function() {
			$rootScope.socket.on('all_answers', function(msg) {
				$rootScope.socket.removeListener("all_answers");
				$scope.$apply(function() {
					if (msg.id == device.uuid) {
						if (!angular.isUndefined(msg.quick) && msg.quick == true)
							$cordovaVibration.vibrate(100);
						$rootScope.settings.show_answers = true;
						$rootScope.settings.answers = msg.answers;
						console.log("messaggio per me", msg);
						$rootScope.settings.buzz = false;
						console.log("dopo", $rootScope.settings);
					}
					$rootScope.settings.choose_level = false;
				});
			});
		};

		$scope.send_answer = function(answer) {
			$rootScope.socket.emit("send_answer", {id: device.uuid, answer: answer});
			$rootScope.settings.show_answers = false;
			$rootScope.settings.choose_level = false;
		};

		$rootScope.socket.on('game_over', function(msg) {
			$rootScope.socket.removeListener("game_over");
			$scope.$apply(function() {
				console.log("game_over", msg);
				angular.forEach(msg.winner, function(u) {
					if (msg.winner == device.uuid) {
						$rootScope.settings.winner = true;
						$cordovaVibration.vibrate(100);
						$timeout(function() {
							$cordovaVibration.vibrate(100);
							$timeout(function() {
								$cordovaVibration.vibrate(100);
							}, 500);
						}, 500);
					} else {
						$rootScope.settings.winner = false;
					};
					$timeout(function() {
						$scope.show_var = 'show';
					}, 100);
				});
				$timeout(function() {
					$state.go('final');
				}, 10000);
			});
		});

		$rootScope.socket.on('game_songs', function(msg) {
			$rootScope.socket.removeListener("game_songs");
			$scope.$apply(function() {
				console.log("game songs", msg);
				$rootScope.game_songs = msg;
			});
		});

		$scope.buy = function(pack) {
			store.when("pack_"+pack.id).approved(function(p) {
				$rootScope.checkOrders();
      });
			store.order("pack_"+pack.id);
		};
		$scope.vote = function(pack) {
			$rootScope.socket.emit("vote_for_level", {id: pack.id});
			$rootScope.settings.choose_level = false;
		};
	});
